/*
 *  Collision.cpp
 *  RPGEngine
 *
 *  Created by Clint Bellanger on 12/29/09.
 *
 */

#include <algorithm>
#include <stdlib.h>
#include "Collision.h"

using namespace std;

Collision::Collision() {
	tile_resolution = 32;
	tile_shift = 5;
}

void Collision::setmap(unsigned short _colmap[256][256]) {
	for (int i=0; i<256; i++) {
		for (int j=0; j<256; j++) {
			colmap[i][j] = _colmap[i][j];
		}
	}
}

/**
 * This may be the worst way to implement collision detection but it's 5:35am and
 * I have bronchitis.  -Clint
 */
bool Collision::move(int &x, int &y, int step_x, int step_y, int dist) {

	bool diag;
	if (step_x != 0 && step_y != 0) diag = true;
	
	for (int i=0; i<dist; i++) {
		if (is_empty(x + step_x, y + step_y)) {
			x+= step_x;
			y+= step_y;
		}
		else if (diag && is_empty(x + step_x, y)) { // slide along wall
			x+= step_x;
		}
		else if (diag && is_empty(x, y + step_y)) { // slide along wall
			y+= step_y;
		}
		else { // absolute stop
			return false;
		}
	}
	return true;
}

bool Collision::is_empty(int x, int y) {
	int tile_x = x >> tile_shift; // fast div by 32
	int tile_y = y >> tile_shift; // fast div by 32
	if (colmap[tile_x][tile_y] == 0)
		return true;
	return false;
}