/**
 * class GameEngine
 *
 * Hands off the logic and rendering for the current game mode
 *
 * @author Clint Bellanger
 * @license GPL
 */

#ifndef GAMEENGINE
#define GAMEENGINE

#include "SDL.h"
#include "InputState.h"
#include "Avatar.h"
#include "map_iso.h"
#include "Utils.h"

class GameEngine {
private:
	SDL_Surface *screen;
	InputState *inp;
	Avatar *pc;
	Map_Iso *map;
public:
	bool done;
	GameEngine(SDL_Surface *screen, InputState *inp);
	void logic();
	void render();
};

#endif
