#ifndef MAP_ISO_H
#define MAP_ISO_H

#include <iostream>
#include <fstream>
#include <string>
#include "SDL.h"
#include "SDL_image.h"
#include "Utils.h"
#include "tileset.h"
#include "Collision.h"

using namespace std;

struct Map_Trigger_Action {
	int type;
	string s;
	int n1;
	int n2;
	int n3;
};

struct Map_Trigger {
	string id;
	int type;
	int x1;
	int y1;
	int x2;
	int y2;
	int state;
	Map_Trigger_Action acts[8];
};

struct Map_Entity {
	string id;
	int type;
	int x;
	int y;
	int state;
	string source;
};

class Map_Iso {
private:
	SDL_Surface *screen;
	
	string parse_section_title(string tok);
	void parse_key_pair(string tok, string &key, string &val);
	int eatFirstInt(string &s, char separator);

public:
	string id;
	int w;
	int h;
	Point cam;
	Point hero_tile;
	Point spawn;
	int spawn_dir;
	string tileset;
	string music;
	Tileset tset;

	Map_Trigger trig[128];
	Map_Entity ent[128];
	unsigned short background[256][256];
	unsigned short fringe[256][256];
	unsigned short object[256][256];
	unsigned short collision[256][256];
	Collision collider;

	// current/cursors
	string cur_layer;
	int cur_entity;
	int cur_trigger;

	// functions
	Map_Iso(SDL_Surface *_screen);
	int load(string filename);
	void render(Renderable r);
};


#endif
